/******************************************************************************
	
	WANCE Tool
	File	: wance_cli.c
	
*******************************************************************************/

#ifndef	INADDR_NONE
#define	INADDR_NONE	0xffffffff
#endif	/* INADDR_NONE */

#include	"inet.h"

main(argc, argv)
int	argc;
char	*argv[];
{
	int			sockfd;
	struct sockaddr_in	cli_addr, serv_addr;
	struct hostent	*phe;	/* pointer to host information entry	*/

	pname = argv[0];

	/*
	 * Fill in the structure "serv_addr" with the address of the
	 * server that we want to send to.
	 */

	if(argc < 3)
		{
		printf("Usage : wance_cli dest  pkt_size \n\n");
		exit();
		}
	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family      = AF_INET;
    	/* Map host name to IP address, allowing for dotted decimal */
	if ( phe = gethostbyname(argv[1]) )
		{
		printf("Returned from gethostbyname\n");
		memcpy(&serv_addr.sin_addr, phe->h_addr, phe->h_length);
		}
	else if ( (serv_addr.sin_addr.s_addr = inet_addr(argv[1])) == INADDR_NONE )
		{
		printf("Can't get \"%s\" host entry\n", argv[1]);
		exit();
		}
	/*
	serv_addr.sin_addr.s_addr = inet_addr(argv[1]);
*/
	serv_addr.sin_port        = htons(SERV_UDP_PORT);


	/*
	 * Open a UDP socket (an Internet datagram socket).
	 */

	if ( (sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		err_dump("client: can't open datagram socket");

	/*
	 * Bind any local address for us.
	 */

	bzero((char *) &cli_addr, sizeof(cli_addr));	/* zero out */
	cli_addr.sin_family      = AF_INET;
	cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	cli_addr.sin_port        = htons(0);
	if (bind(sockfd, (struct sockaddr *) &cli_addr, sizeof(cli_addr)) < 0)
		err_dump("client: can't bind local address");

	printf("Destination = %s Packet Length = %d\n", argv[1], atoi(argv[2]));
	dg_cli(stdin, sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr), atoi(argv[2]), argv[1]);

	close(sockfd);
	exit(0);
}
